@file:JvmName("_ParamsForRedirectKt")

package ru.landgrafhomyak.db.serdha0.user_commons.construction

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.QueryParam
import ru.landgrafhomyak.db.serdha0.api.queries.DeleteQuery
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery
import ru.landgrafhomyak.db.serdha0.api.queries.UpdateQuery


public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Simple.Constructor.Scope<qUE, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.subqueryParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.subqueryParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, lsqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, lsqUE, *>.paramFromLeftSubquery(
	name: String, leftSubParams0: QueryParam<RT, DT, lsqUE>, vararg leftSubParamsN: QueryParam<RT, DT, lsqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, leftSubParams0.type)
	this.leftSubqueryParams.redirect(leftSubParams0, param)
	for (subParam in leftSubParamsN)
		this.leftSubqueryParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, rsqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, *, rsqUE>.paramFromRightSubquery(
	name: String, rightSubParams0: QueryParam<RT, DT, rsqUE>, vararg rightSubParamsN: QueryParam<RT, DT, rsqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, rightSubParams0.type)
	this.rightSubqueryParams.redirect(rightSubParams0, param)
	for (subParam in rightSubParamsN)
		this.rightSubqueryParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Reducing.Constructor.Scope<qUE, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.sourceParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.sourceParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Folding.Constructor.Scope<qUE, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.sourceParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.sourceParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, fsqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Union.Constructor.Scope<qUE, fsqUE, *>.paramFromFirstSubquery(
	name: String, firstSubParams0: QueryParam<RT, DT, fsqUE>, vararg firstSubParamsN: QueryParam<RT, DT, fsqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, firstSubParams0.type)
	this.firstSubqueryParams.redirect(firstSubParams0, param)
	for (subParam in firstSubParamsN)
		this.firstSubqueryParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, lsqUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Union.Constructor.Scope<qUE, *, lsqUE>.paramFromLastSubquery(
	name: String, lastSubParams0: QueryParam<RT, DT, lsqUE>, vararg lastSubParamsN: QueryParam<RT, DT, lsqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, lastSubParams0.type)
	this.lastSubqueryParams.redirect(lastSubParams0, param)
	for (subParam in lastSubParamsN)
		this.lastSubqueryParams.redirect(subParam, param)
	return param
}


public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.FromSubquery.Constructor.Scope<qUE, *, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.sourceQueryParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.sourceQueryParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.FromSubquery.Constructor.Scope<qUE, *, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.selectorParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.selectorParams.redirect(subParam, param)
	return param
}

public fun <qUE : Any, sqUE : Any, RT, DT : DatabaseType<RT>> DeleteQuery.FromSubquery.Constructor.Scope<qUE, *, sqUE>.paramFromSubquery(
	name: String, subParam0: QueryParam<RT, DT, sqUE>, vararg subParamsN: QueryParam<RT, DT, sqUE>
): QueryParam<RT, DT, qUE> {
	val param = this.queryParam(name, subParam0.type)
	this.selectorParams.redirect(subParam0, param)
	for (subParam in subParamsN)
		this.selectorParams.redirect(subParam, param)
	return param
}