@file:JvmName("_QueryParamKt") // todo query_param_like

package ru.landgrafhomyak.db.serdha0.user_commons.construction

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.QueryParam
import ru.landgrafhomyak.db.serdha0.api.queries.DeleteQuery
import ru.landgrafhomyak.db.serdha0.api.queries.InsertQuery
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery
import ru.landgrafhomyak.db.serdha0.api.queries.UpdateQuery

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Simple.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$left")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, ocUE, *>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$right")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.WithJoin.Constructor.Scope<qUE, *, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Reducing.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Folding.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$first")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Union.Constructor.Scope<qUE, ocUE, *>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$last")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> SelectQuery.Union.Constructor.Scope<qUE, *, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.SingleRow.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$target")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.FromSubquery.Constructor.Scope<qUE, ocUE, *>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.FromSubquery.Constructor.Scope<qUE, *, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> InsertQuery.MultipleRows.Constructor.Scope<qUE, ocUE>.inputColumnLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.inputColumn(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.SingleRow.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$target")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.FromSubquery.Constructor.Scope<qUE, ocUE, *>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.FromSubquery.Constructor.Scope<qUE, *, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> UpdateQuery.MultipleRows.Constructor.Scope<qUE, ocUE>.inputColumnLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.inputColumn(name, column.type)

public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> DeleteQuery.SingleRow.Constructor.Scope<qUE, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)

@JvmName("queryParamLike\$target")
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> DeleteQuery.FromSubquery.Constructor.Scope<qUE, ocUE, *>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)
public fun <qUE : Any, ocUE : Any, RT, DT : DatabaseType<RT>> DeleteQuery.FromSubquery.Constructor.Scope<qUE, *, ocUE>.queryParamLike(
	name: String, column: Column<RT, DT, ocUE>
): QueryParam<RT, DT, qUE> = this.queryParam(name, column.type)