@file:OptIn(LowLevelApi::class)
@file:JvmName("_Row2Table")
@file:Suppress("DuplicatedCode")

package ru.landgrafhomyak.db.serdha0.user_commons.executors

import kotlin.contracts.InvocationKind
import kotlin.contracts.contract
import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.serdha0.api.LowLevelApi
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.Transaction

public suspend inline fun <qUE : Any> Transaction.select(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	transform: (OutputRow<qUE>) -> Unit
) {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			while (oRow._next())
				transform(oRow)
		}
	)
}

public suspend inline fun <qUE : Any> Transaction.select(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	transform: RowConsumer0<qUE, Unit>
): Unit = this.select(compiledQuery, params, transform::transformRow)

public suspend inline fun <qUE : Any> Transaction.select(
	compiledQuery: _Query.Void2Table<qUE>,
	transform: (OutputRow<qUE>) -> Unit
) {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			while (oRow._next())
				transform(oRow)
		}
	)
}

public suspend inline fun <qUE : Any> Transaction.select(
	compiledQuery: _Query.Void2Table<qUE>,
	transform: RowConsumer0<qUE, Unit>
): Unit = this.select(compiledQuery, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRows(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	transform: (OutputRow<qUE>) -> E
): List<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			val dst = ArrayList<E>()
			while (oRow._next())
				dst.add(transform(oRow))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRows(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	transform: RowConsumer0<qUE, E>
): List<E> = this.mapRows(compiledQuery, params, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRows(
	compiledQuery: _Query.Void2Table<qUE>,
	transform: (OutputRow<qUE>) -> E
): List<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			val dst = ArrayList<E>()
			while (oRow._next())
				dst.add(transform(oRow))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRows(
	compiledQuery: _Query.Void2Table<qUE>,
	transform: RowConsumer0<qUE, E>
): List<E> = this.mapRows(compiledQuery, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRowsIndexed(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	firstIndex: Int = 0,
	transform: (OutputRow<qUE>, Int) -> E
): List<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			val dst = ArrayList<E>()
			var i = firstIndex
			while (oRow._next())
				dst.add(transform(oRow, i++))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRowsIndexed(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	firstIndex: Int = 0,
	transform: RowConsumer1<qUE, E>
): List<E> = this.mapRowsIndexed(compiledQuery, params, firstIndex, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRowsIndexed(
	compiledQuery: _Query.Void2Table<qUE>,
	firstIndex: Int = 0,
	transform: (OutputRow<qUE>, Int) -> E
): List<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			val dst = ArrayList<E>()
			var i = firstIndex
			while (oRow._next())
				dst.add(transform(oRow, i++))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRowsIndexed(
	compiledQuery: _Query.Void2Table<qUE>,
	firstIndex: Int = 0,
	transform: RowConsumer1<qUE, E>
): List<E> = this.mapRowsIndexed(compiledQuery, firstIndex, transform::transformRow)

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: C,
	transform: (OutputRow<qUE>) -> E
): C {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			while (oRow._next())
				dst.add(transform(oRow))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: C,
	transform: RowConsumer0<qUE, E>
): C = this.mapRowsTo(compiledQuery, params, dst, transform::transformRow)

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: C,
	transform: (OutputRow<qUE>) -> E
): C {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			while (oRow._next())
				dst.add(transform(oRow))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: C,
	transform: RowConsumer0<qUE, E>
): C = this.mapRowsTo(compiledQuery, dst, transform::transformRow)

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsIndexedTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: C, firstIndex: Int = 0,
	transform: (OutputRow<qUE>, Int) -> E
): C {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			var i = firstIndex
			while (oRow._next())
				dst.add(transform(oRow, i++))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsIndexedTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: C, firstIndex: Int = 0,
	transform: RowConsumer1<qUE, E>
): C = this.mapRowsIndexedTo(compiledQuery, params, dst, firstIndex, transform::transformRow)

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsIndexedTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: C, firstIndex: Int = 0,
	transform: (OutputRow<qUE>, Int) -> E
): C {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			var i = firstIndex
			while (oRow._next())
				dst.add(transform(oRow, i++))
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E, C : MutableCollection<E>> Transaction.mapRowsIndexedTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: C, firstIndex: Int = 0,
	transform: RowConsumer1<qUE, E>
): C = this.mapRowsIndexedTo(compiledQuery, dst, firstIndex, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRowsTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: Array<E>, dstOffset: Int = 0,
	transform: (OutputRow<qUE>) -> E
): Array<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_IO(
		iRow = this._executeQuery(compiledQuery),
		inputAction = params::initializeRow,
		outputAction = { oRow ->
			var i = dstOffset
			while (oRow._next())
				dst[i++] = transform(oRow)
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRowsTo(
	compiledQuery: _Query.Params2Table<qUE>,
	params: RowProducer0<qUE>,
	dst: Array<E>, dstOffset: Int = 0,
	transform: RowConsumer0<qUE, E>
): Array<E> = this.mapRowsTo(compiledQuery, params, dst, dstOffset, transform::transformRow)

public suspend inline fun <qUE : Any, E> Transaction.mapRowsTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: Array<E>, dstOffset: Int = 0,
	transform: (OutputRow<qUE>) -> E
): Array<E> {
	contract {
		callsInPlace(transform, InvocationKind.UNKNOWN)
	}
	_safeAutoClose_O(
		oRow = this._executeQuery(compiledQuery),
		outputAction = { oRow ->
			var i = dstOffset
			while (oRow._next())
				dst[i++] = transform(oRow)
			return dst
		}
	)
}

public suspend inline fun <qUE : Any, E> Transaction.mapRowsTo(
	compiledQuery: _Query.Void2Table<qUE>,
	dst: Array<E>, dstOffset: Int = 0,
	transform: RowConsumer0<qUE, E>
): Array<E> = this.mapRowsTo(compiledQuery, dst, dstOffset, transform::transformRow)