package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@Suppress("ClassName")
public class FLOAT_32(context: DatabaseType.Provider) : DatabaseType._VirtualType<Float, UInt, U_INT_32>(
	wraps = context.U_INT_32,
	allowValuesCaching = true
) {
	override val name: String = "FLOAT"

	override fun _unwrap(w: UInt): Float {
		return Float.fromBits(w.toInt())
	}

	override fun _wrap(w: Float): UInt {
		return w.toRawBits().toUInt()
	}

	override fun _equals(l: Float, r: Float): Boolean {
		return l == r
	}

	override fun _compare(l: Float, r: Float): Int {
		return l.compareTo(r)
	}
}