package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType

@Suppress("ClassName")
public class FLOAT_64(context: DatabaseType.Provider) : DatabaseType._VirtualType<Double, ULong, U_INT_64>(
	wraps = context.U_INT_64,
	allowValuesCaching = true
) {
	override val name: String = "FLOAT_64"

	override fun _unwrap(w: ULong): Double {
		return Double.fromBits(w.toLong())
	}

	override fun _wrap(w: Double): ULong {
		return w.toRawBits().toULong()
	}

	override fun _equals(l: Double, r: Double): Boolean {
		return l == r
	}

	override fun _compare(l: Double, r: Double): Int {
		return l.compareTo(r)
	}
}