package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class S_INT_32(context: DatabaseType.Provider) : DatabaseType._VirtualType<Int, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(4u, true),
	allowValuesCaching = true
) {
	override val name: String = "S_INT_32"

	override fun _unwrap(w: UByteArray): Int {
		return IntSerializers.decode32beI(w, 0)
	}

	override fun _wrap(w: Int): UByteArray {
		return IntSerializers.encode32beI(UByteArray(4), 0, w)
	}

	override fun _equals(l: Int, r: Int): Boolean {
		return l == r
	}

	override fun _compare(l: Int, r: Int): Int {
		return l.compareTo(r)
	}

}