package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class S_INT_64(context: DatabaseType.Provider) : DatabaseType._VirtualType<Long, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(8u, true),
	allowValuesCaching = true
) {
	override val name: String = "S_INT_64"

	override fun _unwrap(w: UByteArray): Long {
		return IntSerializers.decode64beL(w, 0)
	}

	override fun _wrap(w: Long): UByteArray {
		return IntSerializers.encode64beL(UByteArray(8), 0, w)
	}

	override fun _equals(l: Long, r: Long): Boolean {
		return l == r
	}

	override fun _compare(l: Long, r: Long): Int {
		return l.compareTo(r)
	}

}