
package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class S_INT_8(context: DatabaseType.Provider) : DatabaseType._VirtualType<Byte, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(1u, true),
	allowValuesCaching = true
) {
	override val name: String = "S_INT_8"

	override fun _unwrap(w: UByteArray): Byte {
		return IntSerializers.decode8B(w, 0)
	}

	override fun _wrap(w: Byte): UByteArray {
		return IntSerializers.encode8B(UByteArray(1), 0, w)
	}

	override fun _equals(l: Byte, r: Byte): Boolean {
		return l == r
	}

	override fun _compare(l: Byte, r: Byte): Int {
		return l.compareTo(r)
	}

}