package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class U_INT_16(context: DatabaseType.Provider) : DatabaseType._VirtualType<UShort, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(2u, true),
	allowValuesCaching = true
) {
	override val name: String = "U_INT_16"

	override fun _unwrap(w: UByteArray): UShort {
		return IntSerializers.decode16beHu(w, 0)
	}

	override fun _wrap(w: UShort): UByteArray {
		return IntSerializers.encode16beHu(UByteArray(2), 0, w)
	}

	override fun _equals(l: UShort, r: UShort): Boolean {
		return l == r
	}

	override fun _compare(l: UShort, r: UShort): Int {
		return l.compareTo(r)
	}

}