package ru.landgrafhomyak.db.serdha0.user_commons.types

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.utility.IntSerializers

@Suppress("ClassName")
@OptIn(ExperimentalUnsignedTypes::class)
public class U_INT_8(context: DatabaseType.Provider) : DatabaseType._VirtualType<UByte, UByteArray, DatabaseType.BINARY_DATA>(
	wraps = context.BINARY_DATA(1u, true),
	allowValuesCaching = true
) {
	override val name: String = "U_INT_8"

	override fun _unwrap(w: UByteArray): UByte {
		return IntSerializers.decode8Bu(w, 0)
	}

	override fun _wrap(w: UByte): UByteArray {
		return IntSerializers.encode8Bu(UByteArray(1), 0, w)
	}

	override fun _equals(l: UByte, r: UByte): Boolean {
		return l == r
	}

	override fun _compare(l: UByte, r: UByte): Int {
		return l.compareTo(r)
	}

}